/** @file gui.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef GUI_CMDLINE_H
#define GUI_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef GUI_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define GUI_CMDLINE_PARSER_PACKAGE "para_gui"
#endif

#ifndef GUI_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define GUI_CMDLINE_PARSER_VERSION "0.4.0"
#endif

/** @brief Where the command line options are stored */
struct gui_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * config_file_arg;	/**< @brief (default='DEFAULT_CONFIG_FILE').  */
  char * config_file_orig;	/**< @brief (default='DEFAULT_CONFIG_FILE') original value given at command line.  */
  const char *config_file_help; /**< @brief (default='DEFAULT_CONFIG_FILE') help description.  */
  char * loglevel_arg;	/**< @brief set loglevel (default='warning').  */
  char * loglevel_orig;	/**< @brief set loglevel original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel help description.  */
  int timeout_arg;	/**< @brief set timeout (default='30').  */
  char * timeout_orig;	/**< @brief set timeout original value given at command line.  */
  const char *timeout_help; /**< @brief set timeout help description.  */
  char * stat_cmd_arg;	/**< @brief command to read server and audiod status
  data from (default='para_audioc -- stat -p').  */
  char * stat_cmd_orig;	/**< @brief command to read server and audiod status
  data from original value given at command line.  */
  const char *stat_cmd_help; /**< @brief command to read server and audiod status
  data from help description.  */
  char ** key_map_arg;	/**< @brief Map key k to command c using mode m. Mode
  may be d, x or p for display, external and
  paraslash commands, respectively. Of course,
  this option may be given multiple times, one
  for each key mapping..  */
  char ** key_map_orig;	/**< @brief Map key k to command c using mode m. Mode
  may be d, x or p for display, external and
  paraslash commands, respectively. Of course,
  this option may be given multiple times, one
  for each key mapping. original value given at command line.  */
  unsigned int key_map_min; /**< @brief Map key k to command c using mode m. Mode
  may be d, x or p for display, external and
  paraslash commands, respectively. Of course,
  this option may be given multiple times, one
  for each key mapping.'s minimum occurreces */
  unsigned int key_map_max; /**< @brief Map key k to command c using mode m. Mode
  may be d, x or p for display, external and
  paraslash commands, respectively. Of course,
  this option may be given multiple times, one
  for each key mapping.'s maximum occurreces */
  const char *key_map_help; /**< @brief Map key k to command c using mode m. Mode
  may be d, x or p for display, external and
  paraslash commands, respectively. Of course,
  this option may be given multiple times, one
  for each key mapping. help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int config_file_given ;	/**< @brief Whether config_file was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int timeout_given ;	/**< @brief Whether timeout was given.  */
  unsigned int stat_cmd_given ;	/**< @brief Whether stat_cmd was given.  */
  unsigned int key_map_given ;	/**< @brief Whether key_map was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct gui_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gui_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gui_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gui_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gui_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gui_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *gui_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int gui_cmdline_parser (int argc, char * const *argv,
  struct gui_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use gui_cmdline_parser_ext() instead
 */
int gui_cmdline_parser2 (int argc, char * const *argv,
  struct gui_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int gui_cmdline_parser_ext (int argc, char * const *argv,
  struct gui_args_info *args_info,
  struct gui_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int gui_cmdline_parser_dump(FILE *outfile,
  struct gui_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int gui_cmdline_parser_file_save(const char *filename,
  struct gui_args_info *args_info);

/**
 * Print the help
 */
void gui_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void gui_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void gui_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a gui_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void gui_cmdline_parser_params_init(struct gui_cmdline_parser_params *params);

/**
 * Allocates dynamically a gui_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized gui_cmdline_parser_params structure
 */
struct gui_cmdline_parser_params *gui_cmdline_parser_params_create(void);

/**
 * Initializes the passed gui_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void gui_cmdline_parser_init (struct gui_args_info *args_info);
/**
 * Deallocates the string fields of the gui_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void gui_cmdline_parser_free (struct gui_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use gui_cmdline_parser_config_file() instead
 */
int gui_cmdline_parser_configfile (char * const filename,
  struct gui_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int gui_cmdline_parser_config_file (char * const filename,
  struct gui_args_info *args_info,
  struct gui_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int gui_cmdline_parser_required (struct gui_args_info *args_info,
  const char *prog_name);

extern char *gui_cmdline_parser_loglevel_values[] ;	/**< @brief Possible values for loglevel.  */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* GUI_CMDLINE_H */
